package net.wanji.opt.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;
import net.wanji.common.framework.rest.JsonViewObject;
import net.wanji.opt.bo.AddOrUpdateAreaBO;
import net.wanji.opt.bo.PolygonBO;
import net.wanji.opt.service.impl.CrossManageServiceImpl;
import net.wanji.opt.vo.CrossIdAndNameVO;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.ws.rs.core.MediaType;
import java.util.List;

/**
 * 路口管理
 *
 * @author Kent HAN
 */
@Api(value = "CrossController", description = "路口管理")
@RequestMapping("/crossManage")
@RestController
public class CrossController {

    private final CrossManageServiceImpl crossManageService;

    public CrossController(CrossManageServiceImpl crossManageService) {
        this.crossManageService = crossManageService;
    }

    @ApiOperation(value = "框选路口", notes = "框选路口", response = JsonViewObject.class,
            produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    @PostMapping(value = "/selectCrossesByPolygon",
            produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    @ApiResponses({
            @ApiResponse(code = 200, message = "OK", response = JsonViewObject.class),
    })
    public JsonViewObject selectCrossesByPolygon(@RequestBody PolygonBO polygonBO) {
        List<CrossIdAndNameVO> res = crossManageService.selectCrossesByPolygon(polygonBO);
        return JsonViewObject.newInstance().success(res);
    }

    @ApiOperation(value = "新增/修改子区", notes = "新增/修改子区，传ID为修改，不传ID为新增", response = JsonViewObject.class,
            produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    @PostMapping(value = "/addOrUpdateArea",
            produces = MediaType.APPLICATION_JSON, consumes = MediaType.APPLICATION_JSON)
    @ApiResponses({
            @ApiResponse(code = 200, message = "OK", response = JsonViewObject.class),
    })
    public JsonViewObject addOrUpdateArea(@RequestBody AddOrUpdateAreaBO addOrUpdateAreaBO) {
//        crossManageService.addOrUpdateArea(addOrUpdateAreaBO);
        return JsonViewObject.newInstance().success();
    }

}